VERSION 5.00
Begin VB.Form DispatcherForm 
   BackColor       =   &H00C0C0FF&
   BorderStyle     =   0  'None
   Caption         =   "Software Structure --- Dispatcher"
   ClientHeight    =   570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1095
   Icon            =   "DispatcherForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   570
   ScaleWidth      =   1095
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnExit 
      Caption         =   "Crash"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
   Begin VB.Timer MonitorTimer 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   1200
      Top             =   120
   End
   Begin VB.Timer RepairTimer 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   480
      Top             =   600
   End
End
Attribute VB_Name = "DispatcherForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
    
    
Private Const IN_COMPONENT1 = 1
Private Const IN_COMPONENT2 = 2

Dim CurrentPosition As Long

Dim WithEvents comp1Ob As Comp1.Comp1Class
Attribute comp1Ob.VB_VarHelpID = -1
Dim WithEvents comp2Ob As Comp2.Comp2Class
Attribute comp2Ob.VB_VarHelpID = -1

Dim ErrSrc As String

Private Sub ProcessAction(ByVal Action As String, ByVal Arg1 As String, ByVal Arg2 As String)
On Error Resume Next
Dim LCaseAction As String

    LCaseAction = LCase(Action)
    
    If LCaseAction = "comp2" Then
        CurrentPosition = IN_COMPONENT2
        CheckAndRepairComp2
        comp2Ob.TopMost False
        comp1Ob.Visble = False
        Exit Sub
        
    End If
    
    If LCaseAction = "comp1" Then
        CurrentPosition = IN_COMPONENT1
        CheckAndRepairComp1
        comp1Ob.TopMost False
        comp2Ob.Visble = False
        Exit Sub
    End If
End Sub



Private Sub btnExit_Click()
On Error Resume Next
    Crash
    Exit Sub
    
    ClearObjects
    End
End Sub

Private Sub comp1Ob_ProcessAction(ByVal Action As String, ByVal Arg1 As String, ByVal Arg2 As String)
On Error Resume Next

    ProcessAction Action, "", ""
End Sub


Private Sub comp2Ob_ProcessAction(ByVal Action As String, ByVal Arg1 As String, ByVal Arg2 As String)
On Error Resume Next

    ProcessAction Action, "", ""
End Sub

Private Sub Form_Load()
On Error Resume Next

    'ִгʼ
    Left = Screen.Width - Width
    Top = 10 * Screen.TwipsPerPixelY
    SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H43
    
    EnterLoop
End Sub

Private Sub ClearObjects()
On Error Resume Next

    'ִ
    Width = 0

    If Not (comp1Ob Is Nothing) Then
        comp1Ob.UnloadIt
        Set comp1Ob = Nothing
    End If

    If Not (comp2Ob Is Nothing) Then
        comp2Ob.UnloadIt
        Set comp2Ob = Nothing
    End If

End Sub


Private Sub EnterLoop()
On Error Resume Next

    CreateComp1
    
    CheckAndRepairComp1
    comp1Ob.TopMost False
    
    CreateComp2
    
    CurrentPosition = IN_COMPONENT1
    MonitorTimer.Enabled = True
End Sub

Private Sub CreateComp1()
On Error Resume Next

    Set comp1Ob = Nothing
    Set comp1Ob = CreateObject("Comp1.Comp1Class")
    comp1Ob.RegisterItself comp1Ob
    comp1Ob.Left = 0
    comp1Ob.Top = 0
    comp1Ob.Width = Screen.Width
    comp1Ob.Height = Screen.Height
End Sub

Private Sub CreateComp2()
On Error Resume Next

    Set comp2Ob = Nothing
    Set comp2Ob = CreateObject("Comp2.Comp2Class")
    comp2Ob.RegisterItself comp2Ob
    comp2Ob.Left = 0
    comp2Ob.Top = 0
    comp2Ob.Width = Screen.Width
    comp2Ob.Height = Screen.Height
End Sub

Property Let Func(FuncStr As String)
On Error Resume Next


On Error GoTo err1
    StatusOk = ""
    
        If LCase(FuncStr) = "DispatchStatus" Then
            StatusOk = "ok"
            Exit Property
        End If
        
        ErrSrc = "comp1"
        If comp1Ob.Status <> "Ok" Then
        End If
        
        ErrSrc = "comp2"
        If comp2Ob.Status <> "Ok" Then
        End If
        
        StatusOk = "ok"
        Exit Property
err1:
        RepairTimer.Enabled = True
        MonitorTimer.Enabled = False

        Exit Property
End Property


Private Sub MonitorTimer_Timer()
On Error Resume Next

        Func = ""
End Sub

Private Sub RepairTimer_Timer()
On Error Resume Next

    RepairTimer.Enabled = False
    If LCase(ErrSrc) = "comp1" Then
        CreateComp1
    End If
    
    If LCase(ErrSrc) = "comp2" Then
        CreateComp2
    End If
    
    If CurrentPosition = IN_COMPONENT1 Then
        comp1Ob.TopMost True
    End If
    
    If CurrentPosition = IN_COMPONENT2 Then
        comp2Ob.TopMost True
    End If
    
    MonitorTimer.Enabled = True

End Sub



Private Function CheckAndRepairComp1(Optional needDisplay As Boolean)
On Error GoTo FoundErr
Dim St As String

        St = comp1Ob.Status
        Exit Function
FoundErr:
        CreateComp1
        If Not IsMissing(needDisplay) Then
            comp1Ob.TopMost False
        End If
        Resume Next
End Function


Private Function CheckAndRepairComp2(Optional needDisplay As Boolean)
On Error GoTo FoundErr
Dim St As String

        St = comp2Ob.Status
        Exit Function
FoundErr:
        CreateComp2
        If Not IsMissing(needDisplay) Then
            comp2Ob.TopMost False
        End If
        Resume Next
End Function


